#ifndef definicions_fetes
#define definicions_fetes

/*Tipus de paquets Art-net*/

#define codi_poll 0x2000
#define codi_pollreply 0x2100
#define codi_artdmx 0x5000
#define codi_address 0x6000
#define codi_ipprog 0xf800
#define codi_ipprogreply 0xf900

#define buffer_max 530

#define mida_poll 14
#define mida_artdmx 530  
#define mida_address 108 
#define mida_ipprog 34 


typedef struct __attribute__((packed))  
{
	uint8_t id[8];                   
	uint16_t opcode;                  
	uint8_t protverhi;                
	uint8_t protverlo;                
	uint8_t netswitch;		
	uint8_t filler;                  
	uint8_t shortname[18]; 
	uint8_t longname[64];   
	uint8_t swin[4];   	
	uint8_t swout[4];   	
	uint8_t subswitch;	   	
	uint8_t swvideo;		   	
	uint8_t command;                  
} paquet_artaddress_t;


typedef struct __attribute__((packed))
{
	uint8_t id[8];                    
	uint16_t opcode;                 
	uint8_t protverhi;                
	uint8_t protverlo;               
	uint8_t filler1;	                
	uint8_t filler2;                  
	uint8_t command;			
	uint8_t filler4;			 
	uint8_t progip3;			 
	uint8_t progip2;
	uint8_t progip1;
	uint8_t progip0;
	uint8_t progsm3;			  
	uint8_t progsm2;
	uint8_t progsm1;
	uint8_t progsm0;
	uint8_t progporthi;		  
	uint8_t progportlo;
	uint8_t spare1;			 
	uint8_t spare2;
	uint8_t spare3;
	uint8_t spare4;
	uint8_t spare5;
	uint8_t spare6;
	uint8_t spare7;
	uint8_t spare8;
} paquet_artipprog_t;


typedef struct __attribute__((packed))
{
	uint8_t id[8];                    
	uint16_t opcode;                  
	uint8_t protverhi;                
	uint8_t protverlo;                
	uint8_t filler1;
	uint8_t filler2;
	uint8_t filler3;			  
	uint8_t filler4;			  
	uint8_t progip3;			  
	uint8_t progip2;
	uint8_t progip1;
	uint8_t progip0;
	uint8_t progsm3;			  
	uint8_t progsm2;
	uint8_t progsm1;
	uint8_t progsm0;
	uint8_t progporthi;			  
	uint8_t progportlo;
	uint8_t status;			
	uint8_t spare2;			
	uint8_t spare3;
	uint8_t spare4;
	uint8_t spare5;
	uint8_t spare6;
	uint8_t spare7;
	uint8_t spare8;
} paquet_ipprogreply_t;


typedef struct __attribute__((packed)) 
{
  uint8_t  id[8];
  uint16_t opcode;
  uint8_t  ip[4];
  uint16_t port;
  uint8_t  verh;
  uint8_t  ver;
  uint8_t  subh;
  uint8_t  sub;
  uint8_t  oemh;
  uint8_t  oem;
  uint8_t  ubea;
  uint8_t  status1;
  uint8_t  etsaman[2];
  uint8_t  shortname[18];
  uint8_t  longname[64];
  uint8_t  nodereport[64];
  uint8_t  numbportsh;
  uint8_t  numbports;
  uint8_t  porttypes[4];
  uint8_t  goodinput[4];
  uint8_t  goodoutput[4];
  uint8_t  swin[4];
  uint8_t  swout[4];
  uint8_t  swvideo;
  uint8_t  swmacro;
  uint8_t  swremote;
  uint8_t  sp1;
  uint8_t  sp2;
  uint8_t  sp3;
  uint8_t  style;
  uint8_t  mac[6];
  uint8_t  bindip[4];
  uint8_t  bindindex;
  uint8_t  status2;
  uint8_t  filler[26];
} paquet_pollreply_t;


#endif 
